// D import file generated from 'src\core\time.d'
module core.time;
private template _mkpos(T)
{
auto  _mkpos(T val)
{
return 0 > val ? -val : val;
}
}

struct Duration
{
    alias int DayType;
    alias int HourType;
    alias int MinType;
    alias int SecType;
    alias long FracType;
    alias long TickType;
    this(HourType h, MinType m, SecType s = 0, FracType f = 0)
{
m_ticks = toTicks(h,m,s,f);
}
    this(Duration other)
{
m_ticks = other.m_ticks;
}
    const @property nothrow HourType hours()
{
return cast(HourType)(ticks / (3600 * ticksPerSecond));
}

    const @property nothrow MinType minutes()
{
return cast(MinType)(ticks / (60 * ticksPerSecond) % 60);
}

    const @property nothrow SecType seconds()
{
return cast(SecType)(ticks / ticksPerSecond % 60);
}

    const @property nothrow SecType totalSeconds()
{
return cast(SecType)(ticks / ticksPerSecond);
}

    const @property nothrow TickType totalMilliseconds();

    const @property nothrow TickType totalMicroseconds();

    const @property nothrow TickType totalNanoseconds();

    const @property nothrow FracType fractionalSeconds()
{
return ticks % ticksPerSecond;
}

    const @property nothrow TickType ticks()
{
return m_ticks;
}

    const @property nothrow bool isNegative()
{
return 0 > ticks;
}

    const @property nothrow bool isNegInfinity()
{
return false;
}

    const @property nothrow bool isPosInfinity()
{
return false;
}

    const @property nothrow bool isNotDateTime()
{
return false;
}

    const @property nothrow bool isSpecial()
{
return false;
}

    const @property Duration invertSign()
{
return Duration(-ticks);
}

    template opUnary(string op) if (op == "-" || op == "+")
{
Duration opUnary()
{
static if(op == "-")
{
return Duration(-m_ticks);
}
else
{
static if(op == "+")
{
return Duration(+m_ticks);
}

}

}
}
    template opBinary(string op) if (op == "+" || op == "-" || op == "*" || op == "/")
{
Duration opBinary(Duration other)
{
auto x = this;
return x.opOpAssign!(op)(other);
}
}
    template opOpAssign(string op) if (op == "+" || op == "-" || op == "*" || op == "/")
{
Duration opOpAssign(Duration other)
{
static if(op == "+")
{
m_ticks += other.m_ticks;
}
else
{
static if(op == "-")
{
m_ticks -= other.m_ticks;
}
else
{
static if(op == "*")
{
m_ticks *= other.m_ticks;
}
else
{
static if(op == "/")
{
m_ticks /= other.m_ticks;
}

}

}

}

return this;
}
}
    const nothrow equals_t opEquals(ref const(Duration) other)
{
return m_ticks == other.m_ticks;
}

    const nothrow int opCmp(ref const(Duration) other)
{
return m_ticks < other.m_ticks ? -1 : m_ticks > other.m_ticks ? 1 : 0;
}

    static @property nothrow ushort numFractionalDigits()
{
return 9;
}

    static @property nothrow TickType ticksPerSecond()
{
return 1000000000;
}

    static @property Duration unit()
{
return Duration(0,0,0,1);
}

    private 
{
    TickType toTicks(HourType h, MinType m, SecType s, FracType f);
    this(TickType t)
{
m_ticks = t;
}
    private TickType m_ticks;

}
}
Duration hours(Duration.HourType n)
{
return Duration(n,0,0,0);
}
Duration minutes(Duration.MinType n)
{
return Duration(0,n,0,0);
}
Duration seconds(Duration.SecType n)
{
return Duration(0,0,n,0);
}
Duration milliseconds(Duration.FracType n);
Duration microseconds(Duration.FracType n);
Duration nanoseconds(Duration.FracType n);
